## apparmor 2.13.3

=== binutils/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 2015
#    Canonical Ltd. (All rights reserved)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
# ----------------------------------------------------------------------
NAME=aa-binutils
all:
COMMONDIR=../common/

include $(COMMONDIR)/Make.rules

DESTDIR=/
BINDIR=${DESTDIR}/usr/bin
LOCALEDIR=/usr/share/locale
MANPAGES=aa-enabled.1 aa-exec.1

WARNINGS = -Wall
EXTRA_WARNINGS = -Wsign-compare -Wmissing-field-initializers -Wformat-security -Wunused-parameter
CPP_WARNINGS =
ifndef CFLAGS
CFLAGS	= -g -O2 -pipe

ifdef DEBUG
CFLAGS += -pg -D DEBUG
endif
ifdef COVERAGE
CFLAGS = -g -pg -fprofile-arcs -ftest-coverage
endif
endif #CFLAGS

EXTRA_CFLAGS = ${CFLAGS} ${CPPFLAGS} ${EXTRA_CXXFLAGS} ${CPP_WARNINGS}

#INCLUDEDIR = /usr/src/linux/include
INCLUDEDIR =

ifdef INCLUDEDIR
	CFLAGS += -I$(INCLUDEDIR)
endif

# Internationalization support. Define a package and a LOCALEDIR
EXTRA_CFLAGS+=-DPACKAGE=\"${NAME}\" -DLOCALEDIR=\"${LOCALEDIR}\"

SRCS = aa_enabled.c
HDRS =
TOOLS = aa-enabled aa-exec

AALIB = -Wl,-Bstatic -lapparmor  -Wl,-Bdynamic -lpthread

ifdef USE_SYSTEM
  # Using the system libapparmor so Makefile dependencies can't be used
  LIBAPPARMOR_A =
  INCLUDE_APPARMOR =
  APPARMOR_H =
  LIBAPPARMOR_LDFLAGS =
else
  LIBAPPARMOR_SRC = ../libraries/libapparmor/
  LOCAL_LIBAPPARMOR_INCLUDE = $(LIBAPPARMOR_SRC)/include
  LOCAL_LIBAPPARMOR_LDPATH = $(LIBAPPARMOR_SRC)/src/.libs

  LIBAPPARMOR_A = $(LOCAL_LIBAPPARMOR_LDPATH)/libapparmor.a
  INCLUDE_APPARMOR = -I$(LOCAL_LIBAPPARMOR_INCLUDE)
  APPARMOR_H = $(LOCAL_LIBAPPARMOR_INCLUDE)/sys/apparmor.h
  LIBAPPARMOR_LDFLAGS = -L$(LOCAL_LIBAPPARMOR_LDPATH)
endif
EXTRA_CFLAGS += $(INCLUDE_APPARMOR)
LDFLAGS += $(LIBAPPARMOR_LDFLAGS)

ifdef V
  VERBOSE = 1
endif
ifndef VERBOSE
  VERBOSE = 0
endif
ifeq ($(VERBOSE),1)
  BUILD_OUTPUT =
  Q =
else
  BUILD_OUTPUT = > /dev/null 2>&1
  Q = @
endif
export Q VERBOSE BUILD_OUTPUT

po/%.pot: %.c
	$(MAKE) -C po $(@F) NAME=$* SOURCES=$*.c

# targets arranged this way so that people who don't want full docs can
# pick specific targets they want.
arch: 	$(TOOLS)

manpages:	$(MANPAGES)

docs:	manpages

indep: docs
	$(Q)$(MAKE) -C po all

all:	arch indep

.PHONY: coverage
coverage:
	$(MAKE) clean $(TOOLS) COVERAGE=1

ifndef USE_SYSTEM
$(LIBAPPARMOR_A):
	@if [ ! -f $@ ]; then \
		echo "error: $@ is missing. Pick one of these possible solutions:" 1>&2; \
		echo "  1) Build against the in-tree libapparmor by building it first and then trying again. See the top-level README for help." 1>&2; \
		echo "  2) Build against the system libapparmor by adding USE_SYSTEM=1 to your make command." 1>&2;\
		exit 1; \
	fi
endif

aa-enabled: aa_enabled.c $(LIBAPPARMOR_A)
	$(CC) $(LDFLAGS) $(EXTRA_CFLAGS) -o $@ $< $(LIBS) $(AALIB) 

aa-exec: aa_exec.c $(LIBAPPARMOR_A)
	$(CC) $(LDFLAGS) $(EXTRA_CFLAGS) -o $@ $< $(LIBS) $(AALIB)

.SILENT: check
.PHONY: check
check: check_pod_files tests

.SILENT: tests
tests: $(TOOLS) $(TESTS)
	echo "no tests atm"

.PHONY: install
install: install-indep install-arch

.PHONY: install-arch
install-arch: arch
	install -m 755 -d ${BINDIR}
	install -m 755 ${TOOLS} ${BINDIR}

.PHONY: install-indep
install-indep: indep
	$(MAKE) -C po install NAME=${NAME} DESTDIR=${DESTDIR}
	$(MAKE) install_manpages DESTDIR=${DESTDIR}

ifndef VERBOSE
.SILENT: clean
endif
.PHONY: clean
clean: pod_clean
	rm -f core core.* *.o *.s *.a *~ *.gcda *.gcno
	rm -f gmon.out
	rm -f $(TOOLS) $(TESTS)
	$(MAKE) -s -C po clean

=== parser/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2000, 2001, 2002, 2004, 2005, 2006, 2007
#    NOVELL (All rights reserved)
#
#    Copyright (c) Christian Boltz 2018
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME=apparmor-parser
all:
COMMONDIR=../common/

include $(COMMONDIR)/Make.rules

DESTDIR=/
APPARMOR_BIN_PREFIX=${DESTDIR}/lib/apparmor
SYSTEMD_UNIT_DIR=${DESTDIR}/usr/lib/systemd/system
CONFDIR=/etc/apparmor
INSTALL_CONFDIR=${DESTDIR}${CONFDIR}
LOCALEDIR=/usr/share/locale
MANPAGES=apparmor.d.5 apparmor.7 apparmor_parser.8 subdomain.conf.5 aa-teardown.8

YACC	:= bison
YFLAGS	:= -d
LEX	:= flex
LEXFLAGS = -B -v
WARNINGS = -Wall
EXTRA_WARNINGS = -Wsign-compare -Wmissing-field-initializers -Wformat-security -Wunused-parameter
CXX_WARNINGS = ${WARNINGS} $(shell for warning in ${EXTRA_WARNINGS} ; do \
			if ${CXX} $${warning} -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then \
				echo "$${warning}"; \
			fi ; \
		done)
CPP_WARNINGS =
ifndef CFLAGS
CFLAGS	= -g -O2 -pipe

ifdef DEBUG
CFLAGS += -pg -D DEBUG
endif
ifdef COVERAGE
CFLAGS = -g -pg -fprofile-arcs -ftest-coverage
endif
endif #CFLAGS

EXTRA_CXXFLAGS = ${CFLAGS} ${CPPFLAGS} ${CXX_WARNINGS} -std=gnu++0x -D_GNU_SOURCE
EXTRA_CFLAGS = ${EXTRA_CXXFLAGS} ${CPP_WARNINGS}

#LEXLIB	:= -lfl

# override this on the make command to point to where the immunix.h file is
# (yeah this is lame, but since we are tied to the kernel so tightly...)
#INCLUDEDIR = /usr/src/linux/include
INCLUDEDIR =

ifdef INCLUDEDIR
	CFLAGS += -I$(INCLUDEDIR)
endif

# Internationalization support. Define a package and a LOCALEDIR
EXTRA_CFLAGS+=-DPACKAGE=\"${NAME}\" -DLOCALEDIR=\"${LOCALEDIR}\"

# Compile-time configuration of the location of the config file
EXTRA_CFLAGS+=-DSUBDOMAIN_CONFDIR=\"${CONFDIR}\"

SRCS = parser_common.c parser_include.c parser_interface.c parser_lex.c \
       parser_main.c parser_misc.c parser_merge.c parser_symtab.c \
       parser_yacc.c parser_regex.c parser_variable.c parser_policy.c \
       parser_alias.c common_optarg.c lib.c network.c \
       mount.cc dbus.cc profile.cc rule.cc signal.cc ptrace.cc \
       af_rule.cc af_unix.cc policy_cache.c
HDRS = parser.h parser_include.h immunix.h mount.h dbus.h lib.h profile.h \
       rule.h common_optarg.h signal.h ptrace.h network.h af_rule.h af_unix.h \
       policy_cache.h
TOOLS = apparmor_parser

OBJECTS = $(patsubst %.cc, %.o, $(SRCS:.c=.o))

AAREDIR= libapparmor_re
AAREOBJECT = ${AAREDIR}/libapparmor_re.a
AAREOBJECTS = $(AAREOBJECT)
AARE_LDFLAGS = -static-libgcc -static-libstdc++ -L. $(LDFLAGS)
AALIB = -Wl,-Bstatic -lapparmor -Wl,-Bdynamic -lpthread

ifdef USE_SYSTEM
  # Using the system libapparmor so Makefile dependencies can't be used
  LIBAPPARMOR_A =
  INCLUDE_APPARMOR =
  APPARMOR_H =
else
  LIBAPPARMOR_SRC = ../libraries/libapparmor
  LOCAL_LIBAPPARMOR_INCLUDE = $(LIBAPPARMOR_SRC)/include
  LOCAL_LIBAPPARMOR_LDPATH = $(LIBAPPARMOR_SRC)/src/.libs

  LIBAPPARMOR_A = $(LOCAL_LIBAPPARMOR_LDPATH)/libapparmor.a
  INCLUDE_APPARMOR = -I$(LOCAL_LIBAPPARMOR_INCLUDE)
  AARE_LDFLAGS += -L$(LOCAL_LIBAPPARMOR_LDPATH)
  APPARMOR_H = $(LOCAL_LIBAPPARMOR_INCLUDE)/sys/apparmor.h
endif
EXTRA_CFLAGS += $(INCLUDE_APPARMOR)

LEX_C_FILES	= parser_lex.c
YACC_C_FILES	= parser_yacc.c parser_yacc.h

TESTS = tst_regex tst_misc tst_symtab tst_variable tst_lib
TEST_CFLAGS = $(EXTRA_CFLAGS) -DUNIT_TEST -Wno-unused-result
TEST_OBJECTS = $(filter-out \
			parser_lex.o \
			parser_yacc.o \
			common_optarg.o \
			parser_main.o \
			policy_cache.o, ${OBJECTS}) \
               $(AAREOBJECTS)
TEST_LDFLAGS = $(AARE_LDFLAGS)
TEST_LDLIBS = $(AALIB)

ifdef V
  VERBOSE = 1
endif
ifndef VERBOSE
  VERBOSE = 0
endif
ifeq ($(VERBOSE),1)
  BUILD_OUTPUT =
  Q =
else
  BUILD_OUTPUT = > /dev/null 2>&1
  Q = @
endif
export Q VERBOSE BUILD_OUTPUT

po/${NAME}.pot: ${SRCS} ${HDRS}
	$(MAKE) -C po ${NAME}.pot NAME=${NAME} SOURCES="${SRCS} ${HDRS}"

techdoc.pdf: techdoc.tex
	timestamp=$(shell date --utc "+%Y%m%d%H%M%S%z" -r $< );\
	while pdflatex "\def\fixedpdfdate{$$timestamp}\input $<" ${BUILD_OUTPUT} || exit 1 ; \
		grep -q "Label(s) may have changed" techdoc.log; \
	do :; done

techdoc/index.html: techdoc.pdf
	latex2html -show_section_numbers -split 0 -noinfo -nonavigation -noaddress techdoc.tex ${BUILD_OUTPUT}

techdoc.txt: techdoc/index.html
	w3m -dump $< > $@

# targets arranged this way so that people who don't want full docs can
# pick specific targets they want.
arch: 	$(TOOLS)

manpages:	$(MANPAGES)

htmlmanpages:	$(HTMLMANPAGES)

pdf:	techdoc.pdf

docs:	manpages htmlmanpages
extra_docs: pdf

indep: docs
	$(Q)$(MAKE) -C po all

all:	arch indep

.PHONY: coverage
coverage:
	$(MAKE) clean apparmor_parser COVERAGE=1

ifndef USE_SYSTEM
$(LIBAPPARMOR_A):
	@if [ ! -f $@ ]; then \
		echo "error: $@ is missing. Pick one of these possible solutions:" 1>&2; \
		echo "  1) Build against the in-tree libapparmor by building it first and then trying again. See the top-level README for help." 1>&2; \
		echo "  2) Build against the system libapparmor by adding USE_SYSTEM=1 to your make command." 1>&2;\
		exit 1; \
	fi
endif

apparmor_parser: $(OBJECTS) $(AAREOBJECTS) $(LIBAPPARMOR_A)
	$(CXX) $(LDFLAGS) $(EXTRA_CFLAGS) -o $@ $(OBJECTS) $(LIBS) \
	      ${LEXLIB}  $(AAREOBJECTS) $(AARE_LDFLAGS) $(AALIB)

parser_yacc.c parser_yacc.h: parser_yacc.y parser.h profile.h
	$(YACC) $(YFLAGS) -o parser_yacc.c parser_yacc.y

parser_lex.c: parser_lex.l parser_yacc.h parser.h profile.h mount.h dbus.h policy_cache.h
	$(LEX) ${LEXFLAGS} -o$@ $<

parser_lex.o: parser_lex.c parser.h parser_yacc.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_misc.o: parser_misc.c parser.h parser_yacc.h profile.h cap_names.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_yacc.o: parser_yacc.c parser_yacc.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_main.o: parser_main.c parser.h parser_version.h policy_cache.h libapparmor_re/apparmor_re.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_interface.o: parser_interface.c parser.h profile.h libapparmor_re/apparmor_re.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_include.o: parser_include.c parser.h parser_include.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_merge.o: parser_merge.c parser.h profile.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_regex.o: parser_regex.c parser.h profile.h libapparmor_re/apparmor_re.h libapparmor_re/aare_rules.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_symtab.o: parser_symtab.c parser.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_variable.o: parser_variable.c parser.h profile.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_policy.o: parser_policy.c parser.h parser_yacc.h profile.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_alias.o: parser_alias.c parser.h profile.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_common.o: parser_common.c parser.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

mount.o: mount.cc mount.h parser.h immunix.h rule.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

common_optarg.o: common_optarg.c common_optarg.h parser.h libapparmor_re/apparmor_re.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

policy_cache.o: policy_cache.c policy_cache.h parser.h lib.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

lib.o: lib.c lib.h parser.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

dbus.o: dbus.cc dbus.h parser.h immunix.h parser_yacc.h rule.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

signal.o: signal.cc signal.h parser.h immunix.h parser_yacc.h rule.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

ptrace.o: ptrace.cc ptrace.h parser.h immunix.h parser_yacc.h rule.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

network.o: network.c network.h parser.h immunix.h parser_yacc.h rule.h af_names.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

af_rule.o: af_rule.cc af_rule.h network.h parser.h profile.h immunix.h parser_yacc.h rule.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

af_unix.o: af_unix.cc af_unix.h network.h af_rule.h parser.h profile.h immunix.h parser_yacc.h $(APPARMOR_H)
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

profile.o: profile.cc profile.h parser.h network.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

rule.o: rule.cc rule.h policydb.h
	$(CXX) $(EXTRA_CFLAGS) -c -o $@ $<

parser_version.h: Makefile
	@echo \#define PARSER_VERSION \"$(VERSION)\" > .ver
	@mv -f .ver $@

# af_names and capabilities generation has moved to common/Make.rules,
# as well as the filtering that occurs for network protocols that
# apparmor should not mediate.

.PHONY: af_names.h
af_names.h:
	echo "$(AF_NAMES)" | LC_ALL=C sed -n -e 's/[ \t]\?AF_MAX[ \t]\+[0-9]\+,//g'  -e 's/[ \t]\+\?AF_\([A-Z0-9_]\+\)[ \t]\+\([0-9]\+\),/#ifndef AF_\1\n#  define AF_\1 \2\n#endif\nAA_GEN_NET_ENT("\L\1", \UAF_\1)\n\n/pg' > $@
	echo "$(AF_NAMES)" | LC_ALL=C sed -n -e 's/.*,[ \t]\+AF_MAX[ \t]\+\([0-9]\+\),\?.*/#define AA_AF_MAX \1\n/p' >> $@
	# cat $@

cap_names.h: /usr/include/linux/capability.h
	echo "$(CAPABILITIES)" | LC_ALL=C sed -n -e "s/[ \\t]\\?CAP_\\([A-Z0-9_]\\+\\)/\{\"\\L\\1\", \\UCAP_\\1\},\\n/pg" > $@

tst_lib: lib.c parser.h $(filter-out lib.o, ${TEST_OBJECTS})
	$(CXX) $(TEST_CFLAGS) -o $@ $< $(filter-out $(<:.c=.o), ${TEST_OBJECTS}) $(TEST_LDFLAGS) $(TEST_LDLIBS)
tst_%: parser_%.c parser.h $(filter-out parser_%.o, ${TEST_OBJECTS})
	$(CXX) $(TEST_CFLAGS) -o $@ $< $(filter-out $(<:.c=.o), ${TEST_OBJECTS}) $(TEST_LDFLAGS) $(TEST_LDLIBS)

.SILENT: check
.PHONY: check
check: check_pod_files tests

.SILENT: tests
tests: apparmor_parser ${TESTS}
	sh -e -c 'for test in ${TESTS} ; do echo "*** running $${test}" && ./$${test}; done'
	$(Q)$(MAKE) -s -C tst tests

# always need to rebuild.
.SILENT: $(AAREOBJECT)
.PHONY: $(AAREOBJECT)
$(AAREOBJECT):
	$(MAKE) -C $(AAREDIR) CFLAGS="$(EXTRA_CXXFLAGS)"

.PHONY: install-rhel4
install-rhel4: install-redhat

.PHONY: install-redhat
install-redhat:
	install -m 755 -d $(DESTDIR)/etc/init.d
	install -m 755 rc.apparmor.$(subst install-,,$@) $(DESTDIR)/etc/init.d/apparmor

.PHONY: install-suse
install-suse: install-systemd
	install -m 755 -d $(DESTDIR)/sbin
	ln -sf service $(DESTDIR)/sbin/rcapparmor

.PHONY: install-slackware
install-slackware:
	install -m 755 -d $(APPARMOR_BIN_PREFIX)/install
	install -m 755 frob_slack_rc $(APPARMOR_BIN_PREFIX)/install
	install -m 755 -d $(DESTDIR)/etc/rc.d
	install -m 755 rc.apparmor.$(subst install-,,$(@)) $(DESTDIR)/etc/rc.d/rc.apparmor

.PHONY: install-debian
install-debian:

.PHONY: install-unknown
install-unknown:

INSTALLDEPS=arch

ifndef DISTRO
DISTRO=$(shell if [ -f /etc/slackware-version ] ; then \
	         echo slackware ; \
	       elif [ -f /etc/debian_version ] ; then \
	         echo debian ;\
	       elif which rpm > /dev/null ; then \
	         if [ "$(rpm --eval '0%{?suse_version}')" != "0" ] ; then \
	             echo suse ;\
	         elif [ "$(rpm --eval '%{_host_vendor}')" = redhat ] ; then \
	            echo rhel4 ;\
	         elif [ "$(rpm --eval '0%{?fedora}')" != "0" ] ; then \
	            echo rhel4 ;\
	         else \
	            echo unknown ;\
	         fi ;\
	       else \
	          echo unknown ;\
	       fi)
endif

ifdef DISTRO
INSTALLDEPS+=install-$(DISTRO)
endif

.PHONY: install
install: install-indep install-arch

.PHONY: install-arch
install-arch: $(INSTALLDEPS)
	install -m 755 -d $(DESTDIR)/sbin
	install -m 755 ${TOOLS} $(DESTDIR)/sbin

.PHONY: install-indep
install-indep: indep
	install -m 755 -d $(INSTALL_CONFDIR)

=== tests/Makefile ===
SUBDIRS=regression stress

.PHONY: clean
clean:
	for dir in $(SUBDIRS) ; do \
		$(MAKE) clean -C $${dir} ; \
	done

=== utils/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2004-2009 NOVELL (All rights reserved)
#    Copyright (c) 2010-2016 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME 		= apparmor-utils
all:
COMMONDIR=../common/

include $(COMMONDIR)/Make.rules

PERLTOOLS = aa-notify
PYTOOLS = aa-easyprof aa-genprof aa-logprof aa-cleanprof aa-mergeprof \
          aa-autodep aa-audit aa-complain aa-enforce aa-disable \
	  aa-status aa-unconfined
TOOLS = ${PERLTOOLS} ${PYTOOLS} aa-decode aa-remove-unknown
PYSETUP = python-tools-setup.py
PYMODULES = $(wildcard apparmor/*.py apparmor/rule/*.py)

MANPAGES = ${TOOLS:=.8} logprof.conf.5

all: docs
	$(MAKE) -C po all
	$(MAKE) -C vim all

.PHONY: docs
docs: ${MANPAGES} ${HTMLMANPAGES}

# need some better way of determining this
DESTDIR=/
BINDIR=${DESTDIR}/usr/sbin
CONFDIR=${DESTDIR}/etc/apparmor
PYPREFIX=/usr

PYFLAKES=pyflakes

po/${NAME}.pot: ${TOOLS} ${PYMODULES}
	$(MAKE) -C po ${NAME}.pot NAME=${NAME} SOURCES="${TOOLS} ${PYMODULES}"

.PHONY: install
install: ${MANPAGES} ${HTMLMANPAGES}
	install -d ${CONFDIR}
	install -m 644 logprof.conf severity.db notify.conf ${CONFDIR}
	install -d ${BINDIR}
	ln -sf aa-status ${BINDIR}/apparmor_status
	# aa-easyprof is installed by python-tools-setup.py
	install -m 755 $(filter-out aa-easyprof, ${TOOLS}) ${BINDIR}
	$(MAKE) -C po install DESTDIR=${DESTDIR} NAME=${NAME}
	$(MAKE) install_manpages DESTDIR=${DESTDIR}
	$(MAKE) -C vim install DESTDIR=${DESTDIR}
	ln -sf aa-status.8 ${DESTDIR}/${MANDIR}/man8/apparmor_status.8
	${PYTHON} ${PYSETUP} install --prefix=${PYPREFIX} --root=${DESTDIR} --version=${VERSION}

.PHONY: clean
ifndef VERBOSE
.SILENT: clean
endif
clean: pod_clean
	rm -f core core.* *.o *.s *.a *~
	$(MAKE) -C po clean
	$(MAKE) -C vim clean
	$(MAKE) -C test clean
	rm -rf staging/ build/
	rm -f apparmor/*.pyc apparmor/rule/*.pyc
	rm -rf apparmor/__pycache__/ apparmor/rule/__pycache__/

# ${CAPABILITIES} is defined in common/Make.rules
.PHONY: check_severity_db
.SILENT: check_severity_db
check_severity_db: /usr/include/linux/capability.h severity.db
	# The sed statement is based on the one in the parser's makefile
	RC=0 ; for cap in ${CAPABILITIES} ; do \
	    if !  grep -q -w $${cap} severity.db ; then \
		echo "Warning! capability $${cap} not found in severity.db" ; \
		RC=1 ; \
	    fi ;\
	done ; \
	test "$$RC" -eq 0

# check_pod_files is defined in common/Make.rules
.PHONY: check
.SILENT: check
check: check_severity_db check_pod_files
	for i in ${PERLTOOLS} ; do \
		perl -c $$i || exit 1; \
	done
	for i in ${PYTOOLS} apparmor test/*.py; do \
		echo Checking $$i; \
		$(PYFLAKES) $$i || exit 1; \
	done
	$(MAKE) -C test check
	$(MAKE) -C vim check

=== parser/tst/Makefile ===
#
PROVE=/usr/bin/prove
TESTS=simple.pl
PARSER_DIR=..
PARSER_BIN=apparmor_parser
PARSER=$(PARSER_DIR)/$(PARSER_BIN)
# parser.conf to use in tests. Note that some test scripts have the parser options hardcoded, so passing PARSER_ARGS=... is not enough to override it.
PARSER_ARGS=--config-file=./parser.conf
PROVE_ARG=-f

ifeq ($(VERBOSE),1)
  PROVE_ARG+=-v
  PYTEST_ARG = -v
else
  VERBOSE=
endif

all: tests

.PHONY: tests error_output gen_dbus gen_xtrans parser_sanity caching minimize equality valgrind
tests: error_output caching minimize equality parser_sanity

GEN_TRANS_DIRS=simple_tests/generated_x/ simple_tests/generated_perms_leading/ simple_tests/generated_perms_safe/ simple_tests/generated_dbus

gen_xtrans: $(GEN_TRANS_DIRS)
	./gen-xtrans.pl

$(GEN_TRANS_DIRS):
	mkdir $@

gen_dbus: $(GEN_TRANS_DIRS)
	./gen-dbus.pl

error_output: $(PARSER)
	LANG=C $(PARSER) $(PARSER_ARGS) -S -I errors >/dev/null errors/okay.sd
	LANG=C $(PARSER) $(PARSER_ARGS) -S -I errors 2>&1 >/dev/null errors/single.sd | \
		grep -q "AppArmor parser error for errors/single.sd in errors/single.sd at line 3: Could not open 'failure'"
	LANG=C $(PARSER) $(PARSER_ARGS) -S -I errors 2>&1 >/dev/null errors/double.sd | \
		grep -q "AppArmor parser error for errors/double.sd in errors/includes/busted at line 66: Could not open 'does-not-exist'"
	LANG=C $(PARSER) $(PARSER_ARGS) -S -I errors 2>&1 >/dev/null errors/modefail.sd | \
		grep -q "AppArmor parser error for errors/modefail.sd in errors/modefail.sd at line 6: syntax error"
	LANG=C $(PARSER) $(PARSER_ARGS) -S -I errors 2>&1 >/dev/null errors/multi_include.sd | \
		grep -q "AppArmor parser error for errors/multi_include.sd in errors/multi_include.sd at line 12: Could not open 'failure'"
	@echo "Error Output: PASS"

parser_sanity: $(PARSER) gen_xtrans gen_dbus
	$(Q)LANG=C APPARMOR_PARSER="$(PARSER)" ${PROVE} ${PROVE_ARG} ${TESTS}

caching: $(PARSER)
	LANG=C ./caching.py -p "$(PARSER)" $(PYTEST_ARG)

minimize: $(PARSER)
	LANG=C APPARMOR_PARSER="$(PARSER) $(PARSER_ARGS)" ./minimize.sh

equality: $(PARSER)
	LANG=C APPARMOR_PARSER="$(PARSER) $(PARSER_ARGS)" ./equality.sh

valgrind: $(PARSER) gen_xtrans gen_dbus
	LANG=C ./valgrind_simple.py -p "$(PARSER) $(PARSER_ARGS)" -v simple_tests

$(PARSER):
	$(MAKE) -C $(PARSER_DIR) $(PARSER_BIN)

clean:
	find $(GEN_TRANS_DIRS) -type f | xargs rm -f
	rm -f gmon.out

=== debian/changelog ===
apparmor (2.13.3-7ubuntu5) focal; urgency=medium

  * snapd 2.44.3+20.04 introduced an apparmor unit of its own to load snap
    policy in /var/lib/snapd/apparmor/profiles. As such, don't load snapd
    policy twice by not loading it in the apparmor unit (LP: 1871148)
    - ubuntu/stop-loading-snapd-profiles.patch: stop loading snapd profiles
    - debian/control: add Breaks on snapd < 2.44.3+20.04~ since prior snapd
      versions assume that apparmor will load the snapd policy on boot
    - debian/apparmor.service: remove the now unneeded RequiresMountsFor on
      /var/lib/snapd/apparmor/profiles
  * drop ubuntu/parser-conf-no-expr-simplify.patch: Optimize=no-expr-simplify
    was added to parser.conf to mitigate slow snap policy compiles on 32bit
    ARM. These days, snapd calls apparmor_parser with "-O no-expr-simplify"
    and loads its snap policy, so drop this delta with upstream and Debian.

 -- Jamie Strandboge <jamie@ubuntu.com>  Sun, 12 Apr 2020 16:11:31 +0000

apparmor (2.13.3-7ubuntu4) focal; urgency=medium

  * debian/apparmor.service: add /var/lib/snapd/apparmor/profiles to
    RequiresMountsFor since Ubuntu's rc.apparmor.functions looks for it
    (LP: #1871148)
  * libnss-systemd.patch: allow accessing the libnss-systemd VarLink sockets
    and DBus APIs. Patch partially based on work by Simon Deziel.
    (LP: #1796911, LP: #1869024)
  * upstream-mr-424-kerberos-dot-dirs.patch: abstractions/kerberosclient:
    allow reading /etc/krb5.conf.d/
  * upstream-mr-442-gnome-user-themes.patch: gnome abstraction: allow reading
    per-user themes from $XDG_DATA_HOME (Closes: #930031)
  * upstream-mr-443-ecryptfs-dirs.patch: abstractions/base: allow read access
    to top-level ecryptfs directories (LP: #1848919)
  * upstream-mr-445-uuidd-request.patch: abstractions/base: allow read access
    to /run/uuidd/request
  * upstream-mr-464-Mesa_i915_perf_interface.patch: let Mesa check if the
    kernel supports the i915 perf interface. Patch from Debian

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 06 Apr 2020 17:47:20 +0000

apparmor (2.13.3-7ubuntu3) focal; urgency=medium

  * Add upstream-abstractions-add-etc-mdns.allow-to-etc-apparmor.d-ab.patch
    (LP: #1869629)

 -- John Johansen <john.johansen@canonical.com>  Wed, 01 Apr 2020 01:05:30 -0700

apparmor (2.13.3-7ubuntu2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:42:36 +0100

apparmor (2.13.3-7ubuntu1) focal; urgency=medium

  * Merge from Debian. Remaining changes:
    - Ubuntu-specific patches:
      + ubuntu/add-chromium-browser.patch
      + ubuntu/communitheme-snap-support.patch
      + ubuntu/mimeinfo-snap-support.patch
      + ubuntu/parser-conf-no-expr-simplify.patch
      + ubuntu/profiles-grant-access-to-systemd-resolved.patch
      + upstream-dont-allow-fontconfig-cache-write.patch
      + upstream-tests-mult-mount-bump-size-of-created-disk.patch
    - debian/apparmor.{install,maintscript}: feature pinning is not used in
      Ubuntu
    - debian/apparmor.preinst: remove cache files on upgrade to 2.13
    - debian/apparmor-profiles.install: install Ubuntu chromium-browser
      profile and abstraction
    - debian/apparmor-profiles.lintian-overrides: update for chromium-browser
      profile having read access to dpkg database for lsb-release
    - debian/apparmor-profiles.postinst: ubuntu-browsers.d/chromium-browser
      abstraction if it doesn't exist
    - debian/control: adjust the Vcs-{Browser,Git} control fields to reflect
      the branch where the Ubuntu packaging is maintained.
    - debian/gbp.conf: use ubuntu/master as the debian-branch
    - debian/patches/series: comment out debian-only patches
    - debian/tests/control and debian/tests/compile-policy: don't test
      thunderbird since the Ubuntu packaging doesn't ship a profile
  * Drop the following patches, no longer needed:
    - python3.8-ac.diff
  * debian/control: drop Breaks on media-hub, mediascanner2.0, messaging-app,
    and webbrowser-app which was needed for upgrades to bionic (LP: #1797242)
  * upstream-adjust-for-ibus-1.5.22.patch: update ibus abstract path for ibus
    1.5.22
  * upstream-adjust-gnome-for-mimeapps.patch: abstractions/gnome: also allow
    /etc/xdg/mimeapps.list (LP: #1792027)

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 17 Dec 2019 15:50:00 +0000

apparmor (2.13.3-7) unstable; urgency=medium

  * Add explicit build dependency on dh-python, so that this package
    can built with python3-defaults 3.7.5-3.

 -- intrigeri <intrigeri@debian.org>  Fri, 15 Nov 2019 10:37:05 +0000

apparmor (2.13.3-6) unstable; urgency=medium

  [ Matthias Klose ]
  * debian/rules: ensure "set -e" is honored (Closes: #943649).
  * Add upstream-mr-430-Fix-a-Python-3.8-autoconf-check.patch (Closes: #943657).

 -- intrigeri <intrigeri@debian.org>  Tue, 29 Oct 2019 18:57:51 +0000

apparmor (2.13.3-5ubuntu5) focal; urgency=medium

  * Don't ignore exit status in debian/rules.
  * Fix a Python 3.8 autoconf check.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 27 Oct 2019 16:38:00 +0200

apparmor (2.13.3-5ubuntu2) focal; urgency=medium

  * No-change rebuild for the perl update.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 19:26:58 +0000

apparmor (2.13.3-5ubuntu1) eoan; urgency=medium

  * Merge new upstream release from Debian. Remaining changes:
    - Ubuntu-specific patches:
      + ubuntu/add-chromium-browser.patch
      + ubuntu/communitheme-snap-support.patch
      + ubuntu/mimeinfo-snap-support.patch
      + ubuntu/parser-conf-no-expr-simplify.patch
      + ubuntu/profiles-grant-access-to-systemd-resolved.patch
    - debian/apparmor.{install,maintscript}: feature pinning is not used in
      Ubuntu
    - debian/apparmor.preinst: remove cache files on upgrade to 2.13
    - debian/apparmor-profiles.install: install Ubuntu chromium-browser
      profile and abstraction
    - debian/apparmor-profiles.lintian-overrides: update for chromium-browser


=== debian/control ===
Source: apparmor
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian AppArmor Team <pkg-apparmor-team@lists.alioth.debian.org>
Uploaders: intrigeri <intrigeri@debian.org>
Section: admin
Priority: optional
Build-Depends: apache2-dev,
               autoconf,
               automake,
               bison,
               bzip2,
               chrpath,
               debhelper-compat (= 12),
               dejagnu,
               dh-apache2,
               dh-python,
               flex,
               liblocale-gettext-perl,
               libpam-dev,
               libtool,
               perl,
               pkg-config,
               po-debconf,
               python3,
               python3-all-dev,
               swig
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/apparmor-team/apparmor/tree/ubuntu/master
Vcs-Git: https://salsa.debian.org/apparmor-team/apparmor.git -b ubuntu/master
Homepage: http://apparmor.net/
Rules-Requires-Root: no

Package: apparmor
Architecture: any
Depends: debconf,
         lsb-base,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: apparmor-profiles-extra,
          apparmor-utils
Pre-Depends: ${misc:Pre-Depends}
Breaks: apparmor-profiles-extra (<< 1.21),
        fcitx-data (<< 1:4.2.9.1-1ubuntu2),
        snapd (<< 2.44.3+20.04~),
Replaces: fcitx-data (<< 1:4.2.9.1-1ubuntu2)
Description: user-space parser utility for AppArmor
 apparmor provides the system initialization scripts needed to use the
 AppArmor Mandatory Access Control system, including the AppArmor Parser
 which is required to convert AppArmor text profiles into machine-readable
 policies that are loaded into the kernel for use with the AppArmor Linux
 Security Module.

Package: apparmor-utils
Architecture: any
Depends: apparmor,
         python3-apparmor (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: vim-addon-manager
Description: utilities for controlling AppArmor
 apparmor-utilities provides utilities that operate on AppArmor
 profiles. Profiles can be created, updated, enforced, set to complain
 mode, and disabled with tools such as aa-genprof, aa-enforce,
 aa-complain and aa-disabled.

Package: apparmor-profiles
Architecture: all
Depends: apparmor (>= 2.8.96~2535-0ubuntu1~),
         ${misc:Depends}
Description: experimental profiles for AppArmor security policies
 apparmor-profiles provides various experimental AppArmor profiles.
 Do not expect these profiles to work out-of-the-box.
 .
 These profiles are not mature enough to be shipped in enforce mode by
 default on Debian. They are shipped in complain mode so that users
 can test them, choose which are desired, and help improve them
 upstream if needed.
 .
 Some even more experimental profiles are included in
 /usr/share/doc/apparmor-profiles/extras/.

Package: libapparmor-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libapparmor1 (= ${binary:Version}),
         ${misc:Depends}
Description: AppArmor development libraries and header files
 libapparmor-dev provides the development libraries and header
 files needed to link against the AppArmor changehat and log parsing
 functions. Also includes the manpages for library functions.

Package: libapparmor1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: changehat AppArmor library
 libapparmor1 provides the shared library used for making use
 of the AppArmor profile and changehat functionality, as well as common
 log parsing routines.

Package: libapparmor-perl
Architecture: any
Multi-Arch: same
Section: perl
Depends: ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Description: AppArmor library Perl bindings
 libapparmor-perl provides the Perl module that contains the language
 bindings for the AppArmor library, libapparmor, which were autogenerated
 via SWIG.

Package: libapache2-mod-apparmor
Architecture: any
Section: httpd
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: changehat AppArmor library as an Apache module
 libapache2-mod-apparmor provides the Apache module needed to declare
 various differing confinement policies when running virtual hosts in the
 webserver by using the changehat abilities exposed through libapparmor.

Package: libpam-apparmor
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: changehat AppArmor library as a PAM module
 libpam-apparmor provides the PAM module needed to declare various
 differing confinement policies when starting PAM sessions by using the
 changehat abilities exposed through libapparmor.

Package: apparmor-notify
Architecture: all
Depends: libapparmor-perl,
         libnotify-bin,
         ${misc:Depends},
         ${perl:Depends}
Description: AppArmor notification system
 apparmor-notify provides a utility to display AppArmor denial
 messages via desktop notifications. The utility can also be used to
 generate summary reports.

Package: python3-libapparmor
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: AppArmor library Python3 bindings
 python3-libapparmor provides the Python3 module that contains the language
 bindings for the AppArmor library, libapparmor, which were autogenerated
 via SWIG.
XS-Python-Version: ${python3:Versions}

Package: python3-apparmor
Architecture: any
Section: python
Depends: python3-libapparmor (>= ${source:Upstream-Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: AppArmor Python3 utility library
 python3-apparmor provides the Python3 modules that implement the
 higher-level AppArmor applications.
XS-Python-Version: ${python3:Versions}

Package: dh-apparmor
Architecture: all
Multi-Arch: foreign
Section: devel
Depends: ${misc:Depends},
         ${perl:Depends}
Suggests: apparmor-easyprof
Description: AppArmor debhelper routines
 dh-apparmor provides the debhelper tools used to install and migrate
 AppArmor profiles. This is normally used from package maintainer scripts
 during install and removal.

Package: apparmor-easyprof
Architecture: all
Multi-Arch: foreign
Depends: python3-apparmor,
         ${misc:Depends},
         ${python3:Depends}
Description: AppArmor easyprof profiling tool
 apparmor-easyprof provides the aa-easyprof utility which is an easy to
 use interface for AppArmor policy generation. aa-easyprof supports the
 use of templates and policy groups to quickly profile an application.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

export PERL_VENDORARCH := $(shell perl -MConfig -e 'print substr($$Config{vendorarch},1)' )
export PYTHON=/usr/bin/python3
export PYTHON_VERSION=3
export PYTHON_VERSIONS=python3

%:
	dh $@ --with=python3,apache2


override_dh_auto_configure:
	cd libraries/libapparmor && sh ./autogen.sh
	dh_auto_configure -D libraries/libapparmor -- --with-perl


override_dh_auto_build:
	# Replace #VERSION# placeholder in dh_apparmor
	sed -i --regexp-extended \
	    -e "s,^#VERSION#,our \$$VERSION = \"$(DEB_VERSION)\";," \
	    debian/debhelper/dh_apparmor
	# Build perl
	dh_auto_build -D libraries/libapparmor
	# Build pythons
	set -e; for py in $(shell py3versions -s) ; do \
		cp -a $(CURDIR)/libraries/libapparmor $(CURDIR)/libraries/libapparmor.$$py && \
		PYTHON=/usr/bin/$$py dh_auto_configure \
			-D libraries/libapparmor.$$py -- --with-python && \
		PYTHON=/usr/bin/$$py dh_auto_build \
			-D libraries/libapparmor.$$py; \
	done

	# Don't run '$(MAKE) check' because of too many perl dependencies
	# and various apparmor files installed on the system
	# Build pythons
	cd utils && $(MAKE)
	for py in $(shell py3versions -s) ; do \
		cp -a $(CURDIR)/utils $(CURDIR)/utils.$$py && \
		(cd utils.$$py && PYTHON=/usr/bin/$$py $(MAKE)) ; \
	done
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	cd binutils && $(MAKE) indep
	cd parser && $(MAKE) indep
else
	cd binutils && $(MAKE) V=1
	cd parser && $(MAKE) V=1
endif
	cd profiles && $(MAKE)


override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	dh_auto_test -Dbinutils -- V=1
	dh_auto_test -Dparser -- V=1
endif
	dh_auto_test -Dlibraries/libapparmor -- V=1
	set -e; for py in $(shell py3versions -s) ; do \
		PYTHON=/usr/bin/$$py dh_auto_test \
			-D libraries/libapparmor.$$py -- PYTHON=/usr/bin/$$py; \
	done
endif


override_dh_auto_clean:
	# Clean up from a Makefile.PL rebuild.
	cd libraries/libapparmor/swig/perl && if test -f Makefile.perl; then \
		$(MAKE) -fMakefile.perl realclean; \
	fi
	# Clean up from an autogen'd build.
	cd $(CURDIR)/libraries/libapparmor && \
		[ ! -f Makefile ] || $(MAKE) distclean
	# Clean up rest of build.
	set -e; for i in binutils utils parser profiles changehat/mod_apparmor \
		  changehat/pam_apparmor ; do \
		[ ! -f $$i/Makefile ] || $(MAKE) -C $$i clean; \
		rm -f $$i/common; \
	done
	# Remove the python build dirs
	rm -rf $(CURDIR)/libraries/libapparmor.python*
	rm -rf $(CURDIR)/utils.python*
	# Try to clean up from an autogen'd build
	cd libraries/libapparmor && [ ! -f Makefile ] || $(MAKE) distclean
	# Remove generated debhelper documentation.
	rm -f $(CURDIR)/debian/debhelper/dh_apparmor.1
	# Remove autoconf build cruft.
	rm -f $(CURDIR)/libraries/libapparmor/test-driver

override_dh_auto_install:
	# Utils
	cd utils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install

	set -e; for py in $(shell py3versions -s) ; do \
		(cd utils.$$py && PYTHON=/usr/bin/$$py $(MAKE) \
	    	DESTDIR=$(CURDIR)/debian/tmp \
	    	install) ; \
	done

	# Parser
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	cd binutils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install-indep

	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/sbin/apparmor_parser
	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/usr/bin/aa-enabled
	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/usr/bin/aa-exec
	cd parser && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install-indep
else
	cd binutils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install

	cd parser && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
endif

	# Changehat via libapparmor
	cd libraries/libapparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# fixup rpath for libapparmor-perl, working around restrictive
	# permissions set by ExtUtils::Install (that dh_fixperms will fix later)
	find $(CURDIR)/debian/tmp/$(PERL_VENDORARCH) -name '*.so' -print0 | \
		xargs -0 -I SO /bin/sh \
			-c "chmod +w SO && chrpath --delete SO && chmod -w SO"

	# Install python swig modules
	set -e; for py in $(shell py3versions -s); do \
		PYTHON=/usr/bin/$$py \
		$(MAKE) -C libraries/libapparmor.$$py \
		DESTDIR=$(CURDIR)/debian/tmp install; \
	done

	# Changehat via mod_apparmor
	cd changehat/mod_apparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in mod_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/apache2/modules/mod_apparmor.so

	# Changehat via libpam-apparmor
	cd changehat/pam_apparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in pam_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/lib/security/pam_apparmor.so

	# Profiles
	# We'd like to keep site.local from being a conffile
	rm ./profiles/apparmor.d/tunables/xdg-user-dirs.d/site.local
	cd profiles && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# set all profiles in apparmor-profiles to complain mode
	cd $(CURDIR)/debian/tmp && sh $(CURDIR)/debian/put-all-profiles-in-complain-mode.sh

	# Build debhelper documentation.
	pod2man -c Debhelper -r "$(DEB_VERSION)" $(CURDIR)/debian/debhelper/dh_apparmor $(CURDIR)/debian/debhelper/dh_apparmor.1

override_dh_installinit:
	dh_installinit --no-start --no-stop-on-upgrade --error-handler=true

override_dh_installsystemd:
	dh_installsystemd --no-start --no-stop-on-upgrade

override_dh_compress:
	dh_compress -Xextras

override_dh_perl:
	dh_perl -p libapparmor-perl -d
	dh_perl --no-package=libapparmor-perl

override_dh_apache2:
	dh_apache2 --noenable

override_dh_install-indep:
	set -e; for profile in $(shell grep ^etc/apparmor.d/ $(CURDIR)/debian/apparmor-profiles.install | \
			 cut -d/ -f3- | grep -v /); do \
	    DH_AUTOSCRIPTDIR=debian/debhelper/ perl debian/debhelper/dh_apparmor --profile-name=$$profile -papparmor-profiles; \
	done
	sed -i -e 's,usr/lib/perl5,$(PERL_VENDORARCH),g' \
	    $(CURDIR)/debian/tmp/etc/apparmor/logprof.conf \
	    $(CURDIR)/debian/tmp/etc/apparmor/severity.db
	dh_install

override_dh_install-arch:
	set -e; for profile in lsb_release nvidia_modprobe; do \
	    DH_AUTOSCRIPTDIR=debian/debhelper/ perl debian/debhelper/dh_apparmor --profile-name=$$profile -papparmor; \
	done
	dh_install
	# Fix permissions so that aa-teardown can execute this file
	chmod 0755 $(CURDIR)/debian/apparmor/lib/apparmor/apparmor.systemd
